Index: /branches/dev_005_AWL/EXTERNAL/XMLF90/makemake_XMLF90.perl
===================================================================
--- /branches/dev_005_AWL/EXTERNAL/XMLF90/makemake_XMLF90.perl	(revision 1803)
+++ /branches/dev_005_AWL/EXTERNAL/XMLF90/makemake_XMLF90.perl	(revision 1804)
@@ -31,5 +31,5 @@
 print MAKEFILE "#-\n";
 print MAKEFILE "#-Q- sxdkrz F_O = \$(F_D) \$(F_P) -C vsafe -size_t64 -I \$(MODDIR)\n";
-print MAKEFILE "#-Q- eshpux F_O = \$(F_D) \$(F_P) -C vsafe -I \$(MODDIR)\n";
+print MAKEFILE "#-Q- es2 F_O = \$(F_D) \$(F_P) -C vsafe -I \$(MODDIR)\n";
 print MAKEFILE "#-Q- sx8brodie F_O = \$(F_D) \$(F_P) -I \$(MODDIR)\n";
 print MAKEFILE "#-Q- sx6nec F_O = \$(F_D) \$(F_P) -size_t64 -Wf\,\"-pvctl loopcnt=999999\" -I \$(MODDIR)\n";
Index: /branches/dev_005_AWL/EXTERNAL/XMLIO_SERVER/AA_make
===================================================================
--- /branches/dev_005_AWL/EXTERNAL/XMLIO_SERVER/AA_make	(revision 1803)
+++ /branches/dev_005_AWL/EXTERNAL/XMLIO_SERVER/AA_make	(revision 1804)
@@ -15,5 +15,5 @@
 #-Q- sx9mercure F_O := $(F_O) -Wf,-ptr byte
 #-Q- sxdkrz F_O := $(F_O) -Wf,-ptr byte
-#-Q- eshpux F_O := $(F_O) -Wf,-ptr byte
+#-Q- es2 F_O := $(F_O) -Wf,-ptr byte
 #-Q- aix6 F_O = $(F_P) -O3 -qextname -qsuffix=cpp=F90 -qsuffix=f=f90  -qmoddir=$(MODDIR) -I $(MODDIR)
 #-Q- aix F_O = $(F_P) -O3 -qextname -qsuffix=cpp=F90 -qsuffix=f=f90  -qmoddir=$(MODDIR) -I $(MODDIR)
Index: /branches/dev_005_AWL/EXTERNAL/XMLIO_SERVER/makemake_XMLIO.perl
===================================================================
--- /branches/dev_005_AWL/EXTERNAL/XMLIO_SERVER/makemake_XMLIO.perl	(revision 1803)
+++ /branches/dev_005_AWL/EXTERNAL/XMLIO_SERVER/makemake_XMLIO.perl	(revision 1804)
@@ -35,5 +35,5 @@
 print MAKEFILE "#-Q- sx9mercure F_O := \$(F_O) -Wf,-ptr byte\n";
 print MAKEFILE "#-Q- sxdkrz F_O := \$(F_O) -Wf,-ptr byte\n";
-print MAKEFILE "#-Q- eshpux F_O := \$(F_O) -Wf,-ptr byte\n";
+print MAKEFILE "#-Q- es2 F_O := \$(F_O) -Wf,-ptr byte\n";
 print MAKEFILE "#-Q- aix6 F_O = \$(F_P) -O3 -qextname -qsuffix=cpp=F90 -qsuffix=f=f90  -qmoddir=\$(MODDIR) -I \$(MODDIR)\n";
 print MAKEFILE "#-Q- aix F_O = \$(F_P) -O3 -qextname -qsuffix=cpp=F90 -qsuffix=f=f90  -qmoddir=\$(MODDIR) -I \$(MODDIR)\n";
Index: /branches/dev_005_AWL/NEMO/NST_SRC/agrif2model.F90
===================================================================
--- /branches/dev_005_AWL/NEMO/NST_SRC/agrif2model.F90	(revision 1803)
+++ /branches/dev_005_AWL/NEMO/NST_SRC/agrif2model.F90	(revision 1804)
@@ -73,4 +73,23 @@
 
    END SUBROUTINE Agrif_clustering_def
+
+   SUBROUTINE Agrif_comm_def(modelcomm)
+
+      !!---------------------------------------------
+      !!   *** ROUTINE Agrif_clustering_def ***
+      !!--------------------------------------------- 
+      Use Agrif_Types
+      Use lib_mpp
+
+      IMPLICIT NONE
+
+      INTEGER :: modelcomm
+
+#if defined key_mpp_mpi
+      modelcomm = mpi_comm_opa
+#endif
+      Return
+
+   END SUBROUTINE Agrif_comm_def
 #else
    SUBROUTINE Agrif2Model
Index: /branches/dev_005_AWL/NEMO/OFF_SRC/DOM/domrea.F90
===================================================================
--- /branches/dev_005_AWL/NEMO/OFF_SRC/DOM/domrea.F90	(revision 1803)
+++ /branches/dev_005_AWL/NEMO/OFF_SRC/DOM/domrea.F90	(revision 1804)
@@ -215,11 +215,10 @@
 
  
-         DO jk = 1,jpk
-            gdept(:,:,jk) = gdept_0(jk)
-            gdepw(:,:,jk) = gdepw_0(jk)
-         END DO
-         
-
          IF( ln_zps ) THEN   
+            ! Vertical coordinates and scales factors
+            CALL iom_get( inum4, jpdom_unknown, 'gdept_0', gdept_0 ) ! depth
+            CALL iom_get( inum4, jpdom_unknown, 'gdepw_0', gdepw_0 )
+            CALL iom_get( inum4, jpdom_unknown, 'e3t_0'  , e3t_0   )
+            CALL iom_get( inum4, jpdom_unknown, 'e3w_0'  , e3w_0   )
                                       ! z-coordinate - partial steps
             IF( nmsh <= 6 ) THEN                                   !    ! 3D vertical scale factors
@@ -233,5 +232,5 @@
             END IF
 
-            IF( nmsh <= 3 ) THEN                                   !    ! 3D depth
+            IF( iom_varid( inum4, 'gdept', ldstop = .FALSE. ) > 0 ) THEN
               CALL iom_get( inum4, jpdom_data, 'gdept', gdept ) ! scale factors
               CALL iom_get( inum4, jpdom_data, 'gdepw', gdepw )
@@ -240,4 +239,9 @@
               CALL iom_get( inum4, jpdom_data, 'hdepw', hdepw )
          
+              DO jk = 1,jpk
+                gdept(:,:,jk) = gdept_0(jk)
+                gdepw(:,:,jk) = gdepw_0(jk)
+              ENDDO
+
               DO jj = 1, jpj
                 DO ji = 1, jpi
@@ -252,12 +256,8 @@
                 END DO
               END DO
+
             ENDIF
 
          ENDIF
-         ! Vertical coordinates and scales factors
-         CALL iom_get( inum4, jpdom_unknown, 'gdept_0', gdept_0 ) ! depth
-         CALL iom_get( inum4, jpdom_unknown, 'gdepw_0', gdepw_0 )
-         CALL iom_get( inum4, jpdom_unknown, 'e3t_0'  , e3t_0   )
-         CALL iom_get( inum4, jpdom_unknown, 'e3w_0'  , e3w_0   )
 # endif
          IF( ln_zco ) THEN
Index: /branches/dev_005_AWL/NEMO/OPA_SRC/DIA/dianam.F90
===================================================================
--- /branches/dev_005_AWL/NEMO/OPA_SRC/DIA/dianam.F90	(revision 1803)
+++ /branches/dev_005_AWL/NEMO/OPA_SRC/DIA/dianam.F90	(revision 1804)
@@ -129,7 +129,5 @@
  
       cdfnam = TRIM(cexper)//TRIM(clave)//"_"//TRIM(cldate1)//"_"//TRIM(cldate2)//"_"//TRIM(cdsuff)
-#if defined key_agrif
-      if ( .NOT. Agrif_Root() ) cdfnam = TRIM(Agrif_CFixed())//'_'//TRIM(cdfnam)
-#endif    
+      IF( .NOT. Agrif_Root() ) cdfnam = TRIM(Agrif_CFixed())//'_'//TRIM(cdfnam)
 
    END SUBROUTINE dia_nam
Index: /branches/dev_005_AWL/NEMO/OPA_SRC/DIA/diawri.F90
===================================================================
--- /branches/dev_005_AWL/NEMO/OPA_SRC/DIA/diawri.F90	(revision 1803)
+++ /branches/dev_005_AWL/NEMO/OPA_SRC/DIA/diawri.F90	(revision 1804)
@@ -629,7 +629,5 @@
       ! Define name, frequency of output and means
       clname = cdfile_name
-#if defined key_agrif
-      if ( .NOT. Agrif_Root() ) clname = TRIM(Agrif_CFixed())//'_'//TRIM(clname)
-#endif
+      IF( .NOT. Agrif_Root() ) clname = TRIM(Agrif_CFixed())//'_'//TRIM(clname)
       zdt  = rdt
       zsto = rdt
Index: /branches/dev_005_AWL/NEMO/OPA_SRC/DOM/dom_oce.F90
===================================================================
--- /branches/dev_005_AWL/NEMO/OPA_SRC/DOM/dom_oce.F90	(revision 1803)
+++ /branches/dev_005_AWL/NEMO/OPA_SRC/DOM/dom_oce.F90	(revision 1804)
@@ -219,4 +219,13 @@
 #else
    LOGICAL, PUBLIC, PARAMETER ::   lk_agrif = .FALSE.   !: agrif flag
+
+CONTAINS
+   LOGICAL FUNCTION Agrif_Root()
+      Agrif_Root = .TRUE.
+   END FUNCTION Agrif_Root
+
+   CHARACTER(len=3) FUNCTION Agrif_CFixed()
+     Agrif_CFixed = '0' 
+   END FUNCTION Agrif_CFixed
 #endif
 
Index: /branches/dev_005_AWL/NEMO/OPA_SRC/DOM/domain.F90
===================================================================
--- /branches/dev_005_AWL/NEMO/OPA_SRC/DOM/domain.F90	(revision 1803)
+++ /branches/dev_005_AWL/NEMO/OPA_SRC/DOM/domain.F90	(revision 1804)
@@ -166,21 +166,17 @@
       ENDIF
 
-#if defined key_agrif
       IF( Agrif_Root() ) THEN
-#endif
-      SELECT CASE ( nleapy )        ! Choose calendar for IOIPSL
-      CASE (  1 ) 
-         CALL ioconf_calendar('gregorian')
-         IF(lwp) WRITE(numout,*) '   The IOIPSL calendar is "gregorian", i.e. leap year'
-      CASE (  0 )
-         CALL ioconf_calendar('noleap')
-         IF(lwp) WRITE(numout,*) '   The IOIPSL calendar is "noleap", i.e. no leap year'
-      CASE ( 30 )
-         CALL ioconf_calendar('360d')
-         IF(lwp) WRITE(numout,*) '   The IOIPSL calendar is "360d", i.e. 360 days in a year'
-      END SELECT
-#if defined key_agrif
-      ENDIF
-#endif
+         SELECT CASE ( nleapy )        ! Choose calendar for IOIPSL
+         CASE (  1 ) 
+            CALL ioconf_calendar('gregorian')
+            IF(lwp) WRITE(numout,*) '   The IOIPSL calendar is "gregorian", i.e. leap year'
+         CASE (  0 )
+            CALL ioconf_calendar('noleap')
+            IF(lwp) WRITE(numout,*) '   The IOIPSL calendar is "noleap", i.e. no leap year'
+         CASE ( 30 )
+            CALL ioconf_calendar('360d')
+            IF(lwp) WRITE(numout,*) '   The IOIPSL calendar is "360d", i.e. 360 days in a year'
+         END SELECT
+      ENDIF
 
       REWIND( numnam )             ! Namelist namdom : space & time domain (bathymetry, mesh, timestep)
Index: /branches/dev_005_AWL/NEMO/OPA_SRC/DOM/domhgr.F90
===================================================================
--- /branches/dev_005_AWL/NEMO/OPA_SRC/DOM/domhgr.F90	(revision 1803)
+++ /branches/dev_005_AWL/NEMO/OPA_SRC/DOM/domhgr.F90	(revision 1804)
@@ -270,5 +270,5 @@
          
 #if defined key_agrif && defined key_eel_r6
-         IF (.Not.Agrif_Root()) THEN
+         IF( .NOT. Agrif_Root() ) THEN
            glam0  = Agrif_Parent(glam0) + (Agrif_ix())*Agrif_Parent(ppe1_m) * 1.e-3
            gphi0  = Agrif_Parent(gphi0) + (Agrif_iy())*Agrif_Parent(ppe2_m) * 1.e-3
@@ -465,5 +465,5 @@
          
 #if defined key_agrif && defined key_eel_r6
-         IF (.Not.Agrif_Root()) THEN
+         IF( .NOT. Agrif_Root() ) THEN
            zphi0 = ppgphi0 - FLOAT( Agrif_Parent(jpjglo)/2)*Agrif_Parent(ppe2_m) / (ra * rad)
          ENDIF
Index: /branches/dev_005_AWL/NEMO/OPA_SRC/DYN/divcur.F90
===================================================================
--- /branches/dev_005_AWL/NEMO/OPA_SRC/DYN/divcur.F90	(revision 1803)
+++ /branches/dev_005_AWL/NEMO/OPA_SRC/DYN/divcur.F90	(revision 1804)
@@ -123,33 +123,27 @@
 
 #if defined key_obc
-#if defined key_agrif
-         IF (Agrif_Root() ) THEN
-#endif
-         ! open boundaries (div must be zero behind the open boundary)
-         !  mpp remark: The zeroing of hdivn can probably be extended to 1->jpi/jpj for the correct row/column
-         IF( lp_obc_east  )   hdivn(nie0p1:nie1p1,nje0  :nje1  ,jk) = 0.e0      ! east
-         IF( lp_obc_west  )   hdivn(niw0  :niw1  ,njw0  :njw1  ,jk) = 0.e0      ! west
-         IF( lp_obc_north )   hdivn(nin0  :nin1  ,njn0p1:njn1p1,jk) = 0.e0      ! north
-         IF( lp_obc_south )   hdivn(nis0  :nis1  ,njs0  :njs1  ,jk) = 0.e0      ! south
-#if defined key_agrif
-         ENDIF
-#endif
+         IF( Agrif_Root() ) THEN
+            ! open boundaries (div must be zero behind the open boundary)
+            !  mpp remark: The zeroing of hdivn can probably be extended to 1->jpi/jpj for the correct row/column
+            IF( lp_obc_east  )   hdivn(nie0p1:nie1p1,nje0  :nje1  ,jk) = 0.e0      ! east
+            IF( lp_obc_west  )   hdivn(niw0  :niw1  ,njw0  :njw1  ,jk) = 0.e0      ! west
+            IF( lp_obc_north )   hdivn(nin0  :nin1  ,njn0p1:njn1p1,jk) = 0.e0      ! north
+            IF( lp_obc_south )   hdivn(nis0  :nis1  ,njs0  :njs1  ,jk) = 0.e0      ! south
+         ENDIF
 #endif         
 #if defined key_bdy
          ! unstructured open boundaries (div must be zero behind the open boundary)
          DO jj = 1, jpj
-           DO ji = 1, jpi
-             hdivn(ji,jj,jk)=hdivn(ji,jj,jk)*bdytmask(ji,jj)
-           END DO
+            DO ji = 1, jpi
+               hdivn(ji,jj,jk)=hdivn(ji,jj,jk)*bdytmask(ji,jj)
+            END DO
          END DO
 #endif         
-#if defined key_agrif
-         if ( .NOT. AGRIF_Root() ) then
-           IF ((nbondi ==  1).OR.(nbondi == 2)) hdivn(nlci-1 , :     ,jk) = 0.e0      ! east
-           IF ((nbondi == -1).OR.(nbondi == 2)) hdivn(2      , :     ,jk) = 0.e0      ! west
-           IF ((nbondj ==  1).OR.(nbondj == 2)) hdivn(:      ,nlcj-1 ,jk) = 0.e0      ! north
-           IF ((nbondj == -1).OR.(nbondj == 2)) hdivn(:      ,2      ,jk) = 0.e0      ! south
-         endif
-#endif    
+         IF( .NOT. AGRIF_Root() ) THEN
+            IF ((nbondi ==  1).OR.(nbondi == 2)) hdivn(nlci-1 , :     ,jk) = 0.e0      ! east
+            IF ((nbondi == -1).OR.(nbondi == 2)) hdivn(2      , :     ,jk) = 0.e0      ! west
+            IF ((nbondj ==  1).OR.(nbondj == 2)) hdivn(:      ,nlcj-1 ,jk) = 0.e0      ! north
+            IF ((nbondj == -1).OR.(nbondj == 2)) hdivn(:      ,2      ,jk) = 0.e0      ! south
+         ENDIF
 
          !                                             ! --------
@@ -341,16 +335,12 @@
 
 #if defined key_obc
-#if defined key_agrif
-         IF ( Agrif_Root() ) THEN
-#endif
-         ! open boundaries (div must be zero behind the open boundary)
-         !  mpp remark: The zeroing of hdivn can probably be extended to 1->jpi/jpj for the correct row/column
-         IF( lp_obc_east  )   hdivn(nie0p1:nie1p1,nje0  :nje1  ,jk) = 0.e0      ! east
-         IF( lp_obc_west  )   hdivn(niw0  :niw1  ,njw0  :njw1  ,jk) = 0.e0      ! west
-         IF( lp_obc_north )   hdivn(nin0  :nin1  ,njn0p1:njn1p1,jk) = 0.e0      ! north
-         IF( lp_obc_south )   hdivn(nis0  :nis1  ,njs0  :njs1  ,jk) = 0.e0      ! south
-#if defined key_agrif
-         ENDIF
-#endif
+         IF( Agrif_Root() ) THEN
+            ! open boundaries (div must be zero behind the open boundary)
+            !  mpp remark: The zeroing of hdivn can probably be extended to 1->jpi/jpj for the correct row/column
+            IF( lp_obc_east  )   hdivn(nie0p1:nie1p1,nje0  :nje1  ,jk) = 0.e0      ! east
+            IF( lp_obc_west  )   hdivn(niw0  :niw1  ,njw0  :njw1  ,jk) = 0.e0      ! west
+            IF( lp_obc_north )   hdivn(nin0  :nin1  ,njn0p1:njn1p1,jk) = 0.e0      ! north
+            IF( lp_obc_south )   hdivn(nis0  :nis1  ,njs0  :njs1  ,jk) = 0.e0      ! south
+         ENDIF
 #endif         
 #if defined key_bdy
@@ -362,12 +352,10 @@
          END DO
 #endif        
-#if defined key_agrif
-         if ( .NOT. AGRIF_Root() ) then
+         IF( .NOT. AGRIF_Root() ) THEN
             IF ((nbondi ==  1).OR.(nbondi == 2)) hdivn(nlci-1 , :     ,jk) = 0.e0      ! east
             IF ((nbondi == -1).OR.(nbondi == 2)) hdivn(2      , :     ,jk) = 0.e0      ! west
             IF ((nbondj ==  1).OR.(nbondj == 2)) hdivn(:      ,nlcj-1 ,jk) = 0.e0      ! north
             IF ((nbondj == -1).OR.(nbondj == 2)) hdivn(:      ,2      ,jk) = 0.e0      ! south
-         endif
-#endif    
+         ENDIF
 
          !                                             ! --------
Index: /branches/dev_005_AWL/NEMO/OPA_SRC/DYN/sshwzv.F90
===================================================================
--- /branches/dev_005_AWL/NEMO/OPA_SRC/DYN/sshwzv.F90	(revision 1803)
+++ /branches/dev_005_AWL/NEMO/OPA_SRC/DYN/sshwzv.F90	(revision 1804)
@@ -157,12 +157,8 @@
 
 #if defined key_obc
-# if defined key_agrif
       IF ( Agrif_Root() ) THEN 
-# endif
          ssha(:,:) = ssha(:,:) * obctmsk(:,:)
          CALL lbc_lnk( ssha, 'T', 1. )  ! absolutly compulsory !! (jmm)
-# if defined key_agrif
-      ENDIF
-# endif
+      ENDIF
 #endif
 
Index: /branches/dev_005_AWL/NEMO/OPA_SRC/IOM/iom.F90
===================================================================
--- /branches/dev_005_AWL/NEMO/OPA_SRC/IOM/iom.F90	(revision 1803)
+++ /branches/dev_005_AWL/NEMO/OPA_SRC/IOM/iom.F90	(revision 1804)
@@ -43,5 +43,5 @@
    LOGICAL, PUBLIC, PARAMETER ::   lk_iomput = .FALSE.       !: iom_put flag
 #endif
-   PUBLIC iom_init, iom_open, iom_close, iom_setkt, iom_varid, iom_get, iom_gettime, iom_rstput, iom_put
+   PUBLIC iom_init, iom_swap, iom_open, iom_close, iom_setkt, iom_varid, iom_get, iom_gettime, iom_rstput, iom_put
 
    PRIVATE iom_rp0d, iom_rp1d, iom_rp2d, iom_rp3d
@@ -86,5 +86,6 @@
       !!----------------------------------------------------------------------
       ! read the xml file
-      CALL event__parse_xml_file( 'iodef.xml' )   ! <- to get from the nameliste (namrun)...
+      IF( Agrif_Root() ) CALL event__parse_xml_file( 'iodef.xml' )   ! <- to get from the nameliste (namrun)...
+      CALL iom_swap
 
       ! calendar parameters
@@ -119,4 +120,22 @@
 
    END SUBROUTINE iom_init
+
+
+   SUBROUTINE iom_swap
+      !!---------------------------------------------------------------------
+      !!                   ***  SUBROUTINE  iom_swap  ***
+      !!
+      !! ** Purpose :  swap context between different agrif grid for xmlio_server
+      !!---------------------------------------------------------------------
+#if defined key_iomput
+
+     IF( TRIM(Agrif_CFixed()) == '0' ) THEN
+        CALL event__swap_context("nemo")
+     ELSE
+        CALL event__swap_context(TRIM(Agrif_CFixed())//"_nemo")
+     ENDIF
+
+#endif
+   END SUBROUTINE iom_swap
 
 
@@ -164,10 +183,4 @@
       ! if iom_open is called for the first time: initialize iom_file(:)%nfid to 0
       ! (could be done when defining iom_file in f95 but not in f90)
-#if ! defined key_agrif
-      IF( iom_open_init == 0 ) THEN
-         iom_file(:)%nfid = 0
-         iom_open_init = 1
-      ENDIF
-#else
       IF( Agrif_Root() ) THEN
          IF( iom_open_init == 0 ) THEN
@@ -176,5 +189,4 @@
          ENDIF
       ENDIF
-#endif
       ! do we read or write the file?
       IF( PRESENT(ldwrt) ) THEN   ;   llwrt = ldwrt
@@ -199,5 +211,4 @@
       ! =============
       clname   = trim(cdname)
-#if defined key_agrif
       IF ( .NOT. Agrif_Root() .AND. .NOT. lliof ) THEN
          iln    = INDEX(clname,'/') 
@@ -206,5 +217,4 @@
          clname=TRIM(cltmpn)//TRIM(Agrif_CFixed())//'_'//TRIM(clname)
       ENDIF
-#endif    
       ! which suffix should we use?
       SELECT CASE (iolib)
Index: /branches/dev_005_AWL/NEMO/OPA_SRC/SBC/sbcmod.F90
===================================================================
--- /branches/dev_005_AWL/NEMO/OPA_SRC/SBC/sbcmod.F90	(revision 1803)
+++ /branches/dev_005_AWL/NEMO/OPA_SRC/SBC/sbcmod.F90	(revision 1804)
@@ -86,12 +86,10 @@
 !!gm here no overwrite, test all option via namelist change: require more incore memory
 !!gm  IF( lk_sbc_cpl       ) THEN   ;   ln_cpl      = .TRUE.   ;   ELSE   ;   ln_cpl      = .FALSE.   ;   ENDIF
-#if defined key_agrif
+
       IF ( Agrif_Root() ) THEN
-#endif
         IF( lk_lim2 )            nn_ice      = 2
         IF( lk_lim3 )            nn_ice      = 3
-#if defined key_agrif
-      ENDIF
-#endif
+      ENDIF
+      !
       IF( cp_cfg == 'gyre' ) THEN
           ln_ana      = .TRUE.   
Index: /branches/dev_005_AWL/NEMO/OPA_SRC/SOL/solmat.F90
===================================================================
--- /branches/dev_005_AWL/NEMO/OPA_SRC/SOL/solmat.F90	(revision 1803)
+++ /branches/dev_005_AWL/NEMO/OPA_SRC/SOL/solmat.F90	(revision 1804)
@@ -142,6 +142,5 @@
 #endif
 
-#if defined key_agrif
-      IF( .NOT.AGRIF_ROOT() ) THEN
+      IF( .NOT. Agrif_Root() ) THEN   ! Fine grid boundaries
          !
          IF( nbondi == -1 .OR. nbondi == 2 )   bmask(2     ,:     ) = 0.e0
@@ -192,5 +191,4 @@
          ! 
       ENDIF
-#endif
 
       ! 2. Boundary conditions 
Index: /branches/dev_005_AWL/NEMO/OPA_SRC/lib_mpp.F90
===================================================================
--- /branches/dev_005_AWL/NEMO/OPA_SRC/lib_mpp.F90	(revision 1803)
+++ /branches/dev_005_AWL/NEMO/OPA_SRC/lib_mpp.F90	(revision 1804)
@@ -112,5 +112,7 @@
    INTEGER ::   mppsize        ! number of process
    INTEGER ::   mpprank        ! process number  [ 0 - size-1 ]
-   INTEGER ::   mpi_comm_opa   ! opa local communicator
+!$AGRIF_DO_NOT_TREAT
+   INTEGER, PUBLIC ::   mpi_comm_opa   ! opa local communicator
+!$AGRIF_END_DO_NOT_TREAT
 
    ! variables used in case of sea-ice
@@ -191,67 +193,13 @@
       WRITE(ldtxt(6),*) '      size in bytes of exported buffer   nn_buffer   = ', nn_buffer
 
-#if defined key_agrif
-      IF( Agrif_Root() ) THEN
-#endif
-         !!bug RB : should be clean to use Agrif in coupled mode
-#if ! defined key_agrif
-         CALL mpi_initialized ( mpi_was_called, code )
-         IF( code /= MPI_SUCCESS ) THEN
-            WRITE(*, cform_err)
-            WRITE(*, *) 'lib_mpp: Error in routine mpi_initialized'
-            CALL mpi_abort( mpi_comm_world, code, ierr )
-         ENDIF
-
-         IF( PRESENT(localComm) .and. mpi_was_called ) THEN
-            mpi_comm_opa = localComm
-            SELECT CASE ( cn_mpi_send )
-            CASE ( 'S' )                ! Standard mpi send (blocking)
-               WRITE(ldtxt(7),*) '           Standard blocking mpi send (send)'
-            CASE ( 'B' )                ! Buffer mpi send (blocking)
-               WRITE(ldtxt(7),*) '           Buffer blocking mpi send (bsend)'
-               CALL mpi_init_opa( ierr ) 
-            CASE ( 'I' )                ! Immediate mpi send (non-blocking send)
-               WRITE(ldtxt(7),*) '           Immediate non-blocking send (isend)'
-               l_isend = .TRUE.
-            CASE DEFAULT
-               WRITE(ldtxt(7),cform_err)
-               WRITE(ldtxt(8),*) '           bad value for cn_mpi_send = ', cn_mpi_send
-               nstop = nstop + 1
-            END SELECT
-         ELSE IF ( PRESENT(localComm) .and. .not. mpi_was_called ) THEN
-            WRITE(ldtxt(7),*) ' lib_mpp: You cannot provide a local communicator '
-            WRITE(ldtxt(8),*) '          without calling MPI_Init before ! '
-            nstop = nstop + 1
-         ELSE
-#endif
-            SELECT CASE ( cn_mpi_send )
-            CASE ( 'S' )                ! Standard mpi send (blocking)
-               WRITE(ldtxt(7),*) '           Standard blocking mpi send (send)'
-               CALL mpi_init( ierr )
-            CASE ( 'B' )                ! Buffer mpi send (blocking)
-               WRITE(ldtxt(7),*) '           Buffer blocking mpi send (bsend)'
-               CALL mpi_init_opa( ierr )
-            CASE ( 'I' )                ! Immediate mpi send (non-blocking send)
-               WRITE(ldtxt(7),*) '           Immediate non-blocking send (isend)'
-               l_isend = .TRUE.
-               CALL mpi_init( ierr )
-            CASE DEFAULT
-               WRITE(ldtxt(7),cform_err)
-               WRITE(ldtxt(8),*) '           bad value for cn_mpi_send = ', cn_mpi_send
-               nstop = nstop + 1
-            END SELECT
-
-#if ! defined key_agrif
-            CALL mpi_comm_dup( mpi_comm_world, mpi_comm_opa, code)
-            IF( code /= MPI_SUCCESS ) THEN
-               WRITE(*, cform_err)
-               WRITE(*, *) ' lib_mpp: Error in routine mpi_comm_dup'
-               CALL mpi_abort( mpi_comm_world, code, ierr )
-            ENDIF
-            !
-         ENDIF
-#endif
-#if defined key_agrif
-      ELSE
+      CALL mpi_initialized ( mpi_was_called, code )
+      IF( code /= MPI_SUCCESS ) THEN
+         WRITE(*, cform_err)
+         WRITE(*, *) 'lib_mpp: Error in routine mpi_initialized'
+         CALL mpi_abort( mpi_comm_world, code, ierr )
+      ENDIF
+
+      IF( mpi_was_called ) THEN
+         !
          SELECT CASE ( cn_mpi_send )
          CASE ( 'S' )                ! Standard mpi send (blocking)
@@ -259,4 +207,5 @@
          CASE ( 'B' )                ! Buffer mpi send (blocking)
             WRITE(ldtxt(7),*) '           Buffer blocking mpi send (bsend)'
+            CALL mpi_init_opa( ierr ) 
          CASE ( 'I' )                ! Immediate mpi send (non-blocking send)
             WRITE(ldtxt(7),*) '           Immediate non-blocking send (isend)'
@@ -267,8 +216,41 @@
             nstop = nstop + 1
          END SELECT
+      ELSE IF ( PRESENT(localComm) .and. .not. mpi_was_called ) THEN
+         WRITE(ldtxt(7),*) ' lib_mpp: You cannot provide a local communicator '
+         WRITE(ldtxt(8),*) '          without calling MPI_Init before ! '
+         nstop = nstop + 1
+      ELSE
+         SELECT CASE ( cn_mpi_send )
+         CASE ( 'S' )                ! Standard mpi send (blocking)
+            WRITE(ldtxt(7),*) '           Standard blocking mpi send (send)'
+            CALL mpi_init( ierr )
+         CASE ( 'B' )                ! Buffer mpi send (blocking)
+            WRITE(ldtxt(7),*) '           Buffer blocking mpi send (bsend)'
+            CALL mpi_init_opa( ierr )
+         CASE ( 'I' )                ! Immediate mpi send (non-blocking send)
+            WRITE(ldtxt(7),*) '           Immediate non-blocking send (isend)'
+            l_isend = .TRUE.
+            CALL mpi_init( ierr )
+         CASE DEFAULT
+            WRITE(ldtxt(7),cform_err)
+            WRITE(ldtxt(8),*) '           bad value for cn_mpi_send = ', cn_mpi_send
+            nstop = nstop + 1
+         END SELECT
+         !
       ENDIF
 
-      mpi_comm_opa = mpi_comm_world
-#endif
+      IF( PRESENT(localComm) ) THEN 
+         IF( Agrif_Root() ) THEN
+            mpi_comm_opa = localComm
+         ENDIF
+      ELSE
+         CALL mpi_comm_dup( mpi_comm_world, mpi_comm_opa, code)
+         IF( code /= MPI_SUCCESS ) THEN
+            WRITE(*, cform_err)
+            WRITE(*, *) ' lib_mpp: Error in routine mpi_comm_dup'
+            CALL mpi_abort( mpi_comm_world, code, ierr )
+         ENDIF
+      ENDIF 
+
       CALL mpi_comm_rank( mpi_comm_opa, mpprank, ierr )
       CALL mpi_comm_size( mpi_comm_opa, mppsize, ierr )
Index: /branches/dev_005_AWL/NEMO/OPA_SRC/opa.F90
===================================================================
--- /branches/dev_005_AWL/NEMO/OPA_SRC/opa.F90	(revision 1803)
+++ /branches/dev_005_AWL/NEMO/OPA_SRC/opa.F90	(revision 1804)
@@ -156,5 +156,7 @@
       CALL opa_closefile
 #if defined key_oasis3 || defined key_oasis4
-      CALL cpl_prism_finalize           ! end coupling and mpp communications with OASIS
+      IF( Agrif_Root() ) THEN
+         CALL cpl_prism_finalize           ! end coupling and mpp communications with OASIS
+     ENDIF 
 #else
       IF( lk_mpp )   CALL mppstop       ! end mpp communications
@@ -191,8 +193,12 @@
 #if defined key_iomput
 # if defined key_oasis3 || defined key_oasis4
-      CALL cpl_prism_init( ilocal_comm )      ! nemo local communicator given by oasis
-      CALL init_ioclient()                    ! io_server will get its communicators (if needed) from oasis (we don't see it)
+      IF( Agrif_Root() ) THEN
+         CALL cpl_prism_init( ilocal_comm )      ! nemo local communicator given by oasis
+         CALL init_ioclient()                    ! io_server will get its communicators (if needed) from oasis (we don't see it)
+      ENDIF
 # else
-      CALL init_ioclient( ilocal_comm )       ! nemo local communicator (used or not) given by the io_server
+      IF( Agrif_Root() ) THEN
+         CALL init_ioclient( ilocal_comm )       ! nemo local communicator (used or not) given by the io_server
+      ENDIF
 # endif
       narea = mynode( cltxt, ilocal_comm )    ! Nodes selection
@@ -200,5 +206,7 @@
 #else
 # if defined key_oasis3 || defined key_oasis4
-      CALL cpl_prism_init( ilocal_comm )      ! nemo local communicator given by oasis
+      IF( Agrif_Root() ) THEN
+         CALL cpl_prism_init( ilocal_comm )      ! nemo local communicator given by oasis
+      ENDIF
       narea = mynode( cltxt, ilocal_comm )    ! Nodes selection (control print return in cltxt)
 # else
Index: /branches/dev_005_AWL/NEMO/OPA_SRC/step.F90
===================================================================
--- /branches/dev_005_AWL/NEMO/OPA_SRC/step.F90	(revision 1803)
+++ /branches/dev_005_AWL/NEMO/OPA_SRC/step.F90	(revision 1804)
@@ -166,6 +166,9 @@
 #if defined key_agrif
       kstp = nit000 + Agrif_Nb_Step()
-!      IF ( Agrif_Root() .and. lwp) Write(*,*) '---'
-!      IF (lwp) Write(*,*) 'Grid Number',Agrif_Fixed(),' time step ',kstp
+!      IF( Agrif_Root() .and. lwp) Write(*,*) '---'
+!      IF(lwp) Write(*,*) 'Grid Number',Agrif_Fixed(),' time step ',kstp
+# if defined key_iomput
+      IF( Agrif_Nbstepint() == 0) CALL iom_swap
+# endif   
 #endif   
       indic = 1                                       ! reset to no error condition
Index: /branches/dev_005_AWL/NEMO/TOP_SRC/C14b/trclsm_c14b.F90
===================================================================
--- /branches/dev_005_AWL/NEMO/TOP_SRC/C14b/trclsm_c14b.F90	(revision 1803)
+++ /branches/dev_005_AWL/NEMO/TOP_SRC/C14b/trclsm_c14b.F90	(revision 1804)
@@ -44,5 +44,5 @@
       INTEGER ::   numnatb
 
-#if defined key_trc_diaadd
+#if defined key_trc_diaadd && ! defined key_iomput
       ! definition of additional diagnostic as a structure
       INTEGER ::   jl, jn
@@ -58,5 +58,5 @@
       !!
       NAMELIST/namc14date/ ndate_beg_b, nyear_res_b
-#if defined key_trc_diaadd
+#if defined key_trc_diaadd && ! defined key_iomput
       NAMELIST/namc14dia/nwritedia, c14dia2d, c14dia3d     ! additional diagnostics
 #endif
@@ -81,5 +81,5 @@
       IF(lwp) WRITE(numout,*) '    initial year (aa)                  nyear_beg_b = ', nyear_beg_b
       !
-#if defined key_trc_diaadd
+#if defined key_trc_diaadd && ! defined key_iomput
 
       ! Namelist namc14dia
